searchNodes=[{"doc":"Transformations is an Elixir library for translating, rotating, reflecting, scaling, shearing, projecting, orthogonalizing, and superimposing arrays of 3D homogeneous coordinates as well as for converting between rotation matrices, Euler angles, and quaternions. Also includes an Arcball control object and functions to decompose transformation matrices.","ref":"Transformations.html","title":"Transformations","type":"module"},{"doc":"Create a new matrix. Examples iex(1)&gt; point = Transformations . matrix ( [ [ 1 ] , [ 1 ] , [ 1 ] , [ 1 ] ] ) #Matrex[4×1] ┌ ┐ │ 1.0 │ │ 1.0 │ │ 1.0 │ │ 1.0 │ └ ┘","ref":"Transformations.html#matrix/1","title":"Transformations.matrix/1","type":"function"},{"doc":"Mirror a shape around the yz plane or the x-axis. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . mirrorx ( ) #Matrex[4×8] ┌ ┐ │ 0.0 - 1.0 - 1.0 0.0 0.0 - 1.0 - 1.0 0.0 │ │ 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 │ │ 0.0 0.0 1.0 1.0 0.0 0.0 1.0 1.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#mirrorx/1","title":"Transformations.mirrorx/1","type":"function"},{"doc":"Mirror a shape around the xz plane or the y-axis. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . mirrory ( ) #Matrex[4×8] ┌ ┐ │ 0.0 1.0 1.0 0.0 0.0 1.0 1.0 0.0 │ │ 0.0 0.0 0.0 0.0 - 1.0 - 1.0 - 1.0 - 1.0 │ │ 0.0 0.0 1.0 1.0 0.0 0.0 1.0 1.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#mirrory/1","title":"Transformations.mirrory/1","type":"function"},{"doc":"Mirror a shape around the xy plane or the z-axis. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . mirrorz ( ) #Matrex[4×8] ┌ ┐ │ 0.0 1.0 1.0 0.0 0.0 1.0 1.0 0.0 │ │ 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 │ │ 0.0 0.0 - 1.0 - 1.0 0.0 0.0 - 1.0 - 1.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#mirrorz/1","title":"Transformations.mirrorz/1","type":"function"},{"doc":"Project a shape down to the yz plane. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . projectx ( ) #Matrex[4×8] ┌ ┐ │ 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 │ │ 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 │ │ 0.0 0.0 1.0 1.0 0.0 0.0 1.0 1.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#projectx/1","title":"Transformations.projectx/1","type":"function"},{"doc":"Project a shape down to the xz plane. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . projecty ( ) #Matrex[4×8] ┌ ┐ │ 0.0 1.0 1.0 0.0 0.0 1.0 1.0 0.0 │ │ 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 │ │ 0.0 0.0 1.0 1.0 0.0 0.0 1.0 1.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#projecty/1","title":"Transformations.projecty/1","type":"function"},{"doc":"Project a shape down to the xy plane. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . projectz ( ) #Matrex[4×8] ┌ ┐ │ 0.0 1.0 1.0 0.0 0.0 1.0 1.0 0.0 │ │ 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 │ │ 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#projectz/1","title":"Transformations.projectz/1","type":"function"},{"doc":"Rotate a shape by angle about the x axis. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . rotatex ( 45 ) #Matrex[4×8] ┌ ┐ │ 0.0 1.0 1.0 0.0 0.0 1.0 1.0 0.0 │ │ 0.0 0.0 - 0.8509 - 0.8509 0.52532 0.52532 - 0.32558 - 0.32558 │ │ 0.0 0.0 0.52532 0.52532 0.8509 0.8509 1.37623 1.37623 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#rotatex/2","title":"Transformations.rotatex/2","type":"function"},{"doc":"Rotate a shape by angle about the y axis. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . rotatey ( 45 ) #Matrex[4×8] ┌ ┐ │ 0.0 0.52532 1.37623 0.8509 0.0 0.52532 1.37623 0.8509 │ │ 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 │ │ 0.0 - 0.8509 - 0.32558 0.52532 0.0 - 0.8509 - 0.32558 0.52532 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#rotatey/2","title":"Transformations.rotatey/2","type":"function"},{"doc":"Rotate a shape by angle about the z axis. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . rotatez ( 45 ) #Matrex[4×8] ┌ ┐ │ 0.0 0.52532 0.52532 0.0 - 0.8509 - 0.32558 - 0.32558 - 0.8509 │ │ 0.0 0.8509 0.8509 0.0 0.52532 1.37623 1.37623 0.52532 │ │ 0.0 0.0 1.0 1.0 0.0 0.0 1.0 1.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#rotatez/2","title":"Transformations.rotatez/2","type":"function"},{"doc":"Scale a shape by xs, ys and zs along the x, y and z axes. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . scale ( 1 , 2 , 3 ) #Matrex[4×8] ┌ ┐ │ 0.0 1.0 1.0 0.0 0.0 1.0 1.0 0.0 │ │ 0.0 0.0 0.0 0.0 2.0 2.0 2.0 2.0 │ │ 0.0 0.0 3.0 3.0 0.0 0.0 3.0 3.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#scale/4","title":"Transformations.scale/4","type":"function"},{"doc":"Shear a shape by a factor of sy, sz along the y and z axes about the x axis. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . shearx ( 2 , 3 ) #Matrex[4×8] ┌ ┐ │ 0.0 1.0 1.0 0.0 0.0 1.0 1.0 0.0 │ │ 0.0 2.0 2.0 0.0 1.0 3.0 3.0 1.0 │ │ 0.0 3.0 4.0 1.0 0.0 3.0 4.0 1.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#shearx/3","title":"Transformations.shearx/3","type":"function"},{"doc":"Shear a shape by a factor of sx, sz along the x and z axes about the y axis. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . sheary ( 2 , 3 ) #Matrex[4×8] ┌ ┐ │ 0.0 1.0 1.0 0.0 2.0 3.0 3.0 2.0 │ │ 0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0 │ │ 0.0 0.0 1.0 1.0 3.0 3.0 4.0 4.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#sheary/3","title":"Transformations.sheary/3","type":"function"},{"doc":"Shear a shape by a factor of sx, sy along the x and y axes about the z axis. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . shearz ( 2 , 3 ) #Matrex[4×8] ┌ ┐ │ 0.0 1.0 3.0 2.0 0.0 1.0 3.0 2.0 │ │ 0.0 0.0 3.0 3.0 1.0 1.0 4.0 4.0 │ │ 0.0 0.0 1.0 1.0 0.0 0.0 1.0 1.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#shearz/3","title":"Transformations.shearz/3","type":"function"},{"doc":"Transition (shift) a shape by xt, yt and zt along the x, y and z axes. Examples iex(1)&gt; shape = Transformations . matrix ( [ [ 0 , 1 , 1 , 0 , 0 , 1 , 1 , 0 ] , [ 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 ] , [ 0 , 0 , 1 , 1 , 0 , 0 , 1 , 1 ] , [ 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 ] ] ) shape |&gt; Transformations . transition ( 1 , 2 , 3 ) #Matrex[4×8] ┌ ┐ │ 1.0 2.0 2.0 1.0 1.0 2.0 2.0 1.0 │ │ 2.0 2.0 2.0 2.0 3.0 3.0 3.0 3.0 │ │ 3.0 3.0 4.0 4.0 3.0 3.0 4.0 4.0 │ │ 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 │ └ ┘","ref":"Transformations.html#transition/4","title":"Transformations.transition/4","type":"function"}]